/**
 * @author awilliams
 */

var BrimstoneROTIHandler = {
	handlers: {},
	
	initialise: function(){
//		BrimstoneROTIHandler.handlers["diplomacy"] = BrimstoneROTIHandler.handleDiplomacy;
		BrimstoneROTIHandler.parameters = BrimstoneData.loadHandlerParameters();
	},
	
	handleClick : function(e) {
//		var path = e.currentTarget.currentURI.path;
		var path = e.target.path;
		if (path.substring(0,14) != "/warbook_roti/") {
			return;
		}
		if (e.originalTarget.localName == "IMG") {
			switch (e.originalTarget.title) {
				case "Build Your Kingdom" : 
					jsdump("Kingdom clicked");
					break;
			}
		}
	},
	
	handleStateStop : function(aWebProgress, aRequest) {
		var match = /\w+:\/\/([^\/]+)(\/.+)/.exec(aRequest.name);
		var host = match[1];
		var path = match[2];
		if (path =="/images/mini_castle.png") {
//			BrimstoneROTIHandler.handleROTIPage(aWebProgress.contentViewer.DOMDocument);
			setTimeout(function() {BrimstoneROTIHandler.handleROTIPage(aWebProgress.contentViewer.DOMDocument)}, 20);		
		}
//		jsdump(aRequest.name);
	},
	
	handlePage: function(host, path, DOM){
//		jsdump("roti: " + path);
	},
	
	handleROTIPage : function(rotiDocument) {
		var mainContent = rotiDocument.getElementById("content");
		var infoBar = rotiDocument.evaluate('.//div[@class="info_bar"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (infoBar) {
			BrimstoneROTIHandler.handleInfoBar(rotiDocument, infoBar);		
		}
		var flashNotice = rotiDocument.evaluate('.//div[@class="flash_notice"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (flashNotice) {
			BrimstoneROTIHandler.handleFlashNotice(rotiDocument, flashNotice);			
		}
		
		var actionsTable = rotiDocument.evaluate('.//table[@class="actions_table hoverable"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (actionsTable) {
			var actionsName = actionsTable.previousSibling.previousSibling.textContent;
			switch (actionsName) {
				case "Kingdom" :
					jsdump("Kingdom page");
					BrimstoneROTIHandler.handleKingdomActions(rotiDocument, actionsTable);
					break;
				case "Army" :
					jsdump("Army page");
					BrimstoneROTIHandler.handleArmyActions(rotiDocument, actionsTable);
					break;
				case "Attack!" :
					jsdump("Attack page");
					break;
				case "Alliances" :
					jsdump("Alliances page");
					break;
				case "Messages" :
					jsdump("Messages page");
					break;
				default :
					jsdump("Unknown page: " + actionsName);
			}
		}
		var heroProfile = rotiDocument.evaluate('.//div[@class="hero_profile"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (heroProfile) {
			BrimstoneROTIHandler.handleHeroPage(rotiDocument, mainContent, heroProfile);
		}
		var searchTable = rotiDocument.evaluate('.//table[@class="actions_table search hoverable"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (searchTable) {
			BrimstoneROTIHandler.handleSearch(rotiDocument, searchTable);
		}

		var messageFeed = rotiDocument.evaluate('.//ul[@class="feed"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (messageFeed) {
			BrimstoneROTIHandler.handleMessageFeed(rotiDocument, messageFeed)
		}
		
	},
	
	handleInfoBar : function(rotiDocument, infoBar) {
		var acresImg = rotiDocument.evaluate('.//img[@title="total acres"]', infoBar, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		var acres = convertToNumber(acresImg.nextSibling.textContent.replace("|", "").trim());
		jsdump("acres: " + acres);
		var troopsImg = rotiDocument.evaluate('.//img[@title="troops"]', infoBar, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		var troops = convertToNumber(troopsImg.nextSibling.textContent.replace("|", "").trim());
		jsdump("troops: " + troops);
		var goldImg = rotiDocument.evaluate('.//img[@title="gold"]', infoBar, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;		
		var gold = convertToNumber(goldImg.nextSibling.textContent.replace("|", "").trim());
		jsdump("gold: " + gold);
		var manaImg = rotiDocument.evaluate('.//img[@title="mana"]', infoBar, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		var mana = convertToNumber(manaImg.nextSibling.textContent.replace("|", "").trim());
		jsdump("mana: " + mana);
	},
	
	handleFlashNotice : function(rotiDocument, flashNotice) {
		var notice = flashNotice.textContent;
		var match = /^You cast/.exec(notice);
		if (match) {
			BrimstoneROTIHandler.handleCast(notice);
			return;
		}

		var match = /You ((won)|(lost)) the battle! You lost ([\d,]+) soldiers, ([\d,]+) knights, ([\d,]+) pikemen, and ([\d,]+) elites. ([\w\s]+) lost ([\d,]+) soldiers, ([\d,]+) knights, ([\d,]+) pikemen, and ([\d,]+) elites.   ?You (only )?gained ([\d,]+) gold and ([\d,]+) acres.You gained ([\d,]+) prestige./.exec(notice);
		if (match) {
			if (match[1] == "won") {
				jsdump("I WON!");			
			} else {
				jsdump("I LOST!");				
			}
			var soldiers = convertToNumber(match[4]);
			jsdump("soldiers: " + soldiers);
			var knights = convertToNumber(match[5]);
			jsdump("knights: " + knights);
			var pikemen = convertToNumber(match[6]);
			jsdump("pikemen: " + pikemen);
			var elites = convertToNumber(match[7]);
			jsdump("elites: " + elites);
			var targetName = match[5];
			var soldiers = convertToNumber(match[8]);
			jsdump("soldiers: " + soldiers);
			var knights = convertToNumber(match[9]);
			jsdump("knights: " + knights);
			var pikemen = convertToNumber(match[10]);
			jsdump("pikemen: " + pikemen);
			var elites = convertToNumber(match[11]);
			jsdump("elites: " + elites);
			var gold = convertToNumber(match[13]);
			jsdump("gold: " + gold);
			var acres = convertToNumber(match[14]);
			jsdump("acres: " + acres);
			var prestige = convertToNumber(match[15]);
			jsdump("prestige: " + prestige);
			return;
		}
		jsdump("UNKNOWN FLASH NOTICE: " + notice);
	},
	
	handleCast : function(notice) {
		var match = /^You cast ([\w\s]+) at ([\w\s]+)\./.exec(notice);
		if (!match) {
			match = /^You cast ([\w\s]+)\./.exec(notice);
		}
		if (match) {
			var spell = match[1];
			if (match[2]) {
				var target = match[2];
			}
			switch(spell) {
				case "Alchemy" :
					break;
				case "Bloodlust" :
					break;
				case "Spell Bubble" :
					break;
				case "Spy" :
					jsdump("target: " + target);
					jsdump(notice);
					var spyMatch = /You detect that your enemy has about ([\d,]+) soldiers, ([\d,]+) knights, ([\d,]+) pikemen, and ([\d,]+) elites./.exec(notice);
					var soldiers = convertToNumber(spyMatch[1]);
					jsdump("soldiers: " + soldiers);
					var knights = convertToNumber(spyMatch[2]);
					jsdump("knights: " + knights);
					var pikemen = convertToNumber(spyMatch[3]);
					jsdump("pikemen: " + pikemen);
					var elites = convertToNumber(spyMatch[4]);
					jsdump("elites: " + elites);
					break;
				jsdump("UNKNOWN SPELL :" + spell);
			}
		}
	},
	
	handleKingdomActions : function(rotiDocument, actionTable) {
		var data = rotiDocument.evaluate('.//td[@class="data"]', actionTable, null, XPathResult.ANY_TYPE, null );
		var emptyLand = convertToNumber(data.iterateNext().textContent);
		jsdump("emptyLand: " + emptyLand);
		var mines = convertToNumber(data.iterateNext().textContent);
		jsdump("mines: " + mines);
		var forts = convertToNumber(data.iterateNext().textContent);
		jsdump("forts: " + forts);
		var barriers = convertToNumber(data.iterateNext().textContent);		
		jsdump("barriers: " + barriers);
	},
	
	handleArmyActions : function(rotiDocument, actionTable) {
		var data = rotiDocument.evaluate('.//td[@class="data"]', actionTable, null, XPathResult.ANY_TYPE, null );
		var soldiers = convertToNumber(data.iterateNext().textContent);
		jsdump("soldiers: " + soldiers);
		var knights = convertToNumber(data.iterateNext().textContent);
		jsdump("knights: " + knights);
		var pikemen = convertToNumber(data.iterateNext().textContent);
		jsdump("pikemen: " + pikemen);
		var elites = convertToNumber(data.iterateNext().textContent);
		jsdump("elites: " + elites);
	},
	
	handleHeroPage : function(rotiDocument, mainContent, heroProfile) {
		// Handle heroProfile
		var heroName = rotiDocument.evaluate('.//div[@class="alias text_info"]', heroProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
		jsdump("Hero Name: " + heroName);
		var heroInfo = rotiDocument.evaluate('.//div[@class="stats text_info"]', heroProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
		var match = /Level (\d+) (\w+)/.exec(heroInfo);
		var heroLevel = match[1];
		jsdump("Hero level: " + heroLevel);
		var heroType = match[2];
		jsdump("Hero type: " + heroType);
		
		// Handle actionsTables
		var actionsTables = rotiDocument.evaluate('.//table[@class="actions_table"]', mainContent, null, XPathResult.ANY_TYPE, null);

		// First actionsTable
		var actionsTable = actionsTables.iterateNext();
		var data = rotiDocument.evaluate('.//td[@class="data"]', actionsTable, null, XPathResult.ANY_TYPE, null );
		var kingdomData = data.iterateNext().textContent;
		var match = /([\d,]+) acres/.exec(kingdomData);
		var acres = convertToNumber(match[1]);
		jsdump("acres: " + acres);
		var armyData = data.iterateNext().textContent;
		var match = /([\d,]+) troops/.exec(armyData);
		var troops = convertToNumber(match[1]);
		jsdump("troops: " + troops);
		var gold = convertToNumber(data.iterateNext().textContent);
		jsdump("gold: " + gold);
		var manaData = data.iterateNext().textContent;
		var match = /([\d,]+)\/([\d,]+)/.exec(manaData);
		var currentMana = convertToNumber(match[1]);
		jsdump("currentMana: " + currentMana);
		var maxMana = convertToNumber(match[2]);
		jsdump("maxMana: " + maxMana);
		var experience = convertToNumber(data.iterateNext().textContent);
		jsdump("experience: " + experience);
		var nextLevelData = data.iterateNext().textContent;
		var match = /([\d,]+) exp/.exec(nextLevelData);
		var nextLevel = convertToNumber(match[1]);
		jsdump("nextLevel: " + nextLevel);
		
		// Second actionsTable - Hero Stats
		var actionsTable = actionsTables.iterateNext();
		var data = rotiDocument.evaluate('.//td[@class="data"]', actionsTable, null, XPathResult.ANY_TYPE, null );
		var strength = convertToNumber(data.iterateNext().textContent);
		jsdump("strength: " + strength);
		var fortitude = convertToNumber(data.iterateNext().textContent);
		jsdump("fortitude: " + fortitude);
		var spellPower = convertToNumber(data.iterateNext().textContent);
		jsdump("spellPower: " + spellPower);
		var spellProtection = convertToNumber(data.iterateNext().textContent);
		jsdump("spellProtection: " + spellProtection);
		
		var iconLists = rotiDocument.evaluate('.//ul[@class="iconlist"]', mainContent, null, XPathResult.ANY_TYPE, null );
		var iconList = iconLists.iterateNext();
		while (iconList) {
			var iconTitle = iconList.previousSibling.previousSibling.textContent.trim();
			switch (iconTitle) {
				case "Hero Items" :
					BrimstoneROTIHandler.handleHeroItems(rotiDocument, iconList);
					break;
				case "Effects On You" :
					BrimstoneROTIHandler.handleHeroEffects(rotiDocument, iconList);
					break;
				default :
					jsdump("UNKNOWN ICONS");
			}
			var iconList = iconLists.iterateNext();
		}
	},
	
	handleHeroItems : function(rotiDocument, iconList) {
		var items = rotiDocument.evaluate('.//li', iconList, null, XPathResult.ANY_TYPE, null );
		var item = items.iterateNext();
		while (item) {
			var onMouseOver = item.getAttribute("onmouseover");
			var match = /'items_exp', '([\w\s]+)'/.exec(onMouseOver);
			var itemName = match[1];
			switch(itemName) {
				case "Infernal Slayer" :
					jsdump("Infernal Slayer!");
					break;
				default :
					jsdump("UNKNOWN HERO ITEM: " + itemName);
			}
			items.iterateNext();  // Ignore the explanation item
			item = items.iterateNext();
		}		
	},

	handleHeroEffects : function(rotiDocument, iconList) {
		var effects = rotiDocument.evaluate('.//li', iconList, null, XPathResult.ANY_TYPE, null );
		var effect = effects.iterateNext();
		while (effect) {
			var onMouseOver = effect.getAttribute("onmouseover");
			var match = /'spell_effects_exp', '([\w\s]+)'/.exec(onMouseOver);
			var effectName = match[1];
			switch(effectName) {
				case "Bloodlust" :
					jsdump("Bloodlust!");
					break;
				default :
					jsdump("UNKNOWN HERO EFFECT: " + effectName);
			}
			effects.iterateNext();  // Ignore the explanation item
			effect = effects.iterateNext();
		}
	},

	handleSearch: function(rotiDocument, searchTable){
		var searchItems = rotiDocument.evaluate('.//td[@class="data"]', searchTable, null, XPathResult.ANY_TYPE, null );
		var searchItem = searchItems.iterateNext();
		while (searchItem) {
			var playerLink = rotiDocument.evaluate('./a', searchItem, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
			var href = playerLink.getAttribute("href");
			jsdump("href: " + href);
			var playerName = playerLink.textContent;
			jsdump("playerName: " + playerName);
			var playerInfo = rotiDocument.evaluate('./span[@class="attack_sub_info"]', searchItem, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
//			| Level 15 Druidess | 1,001 acres
			var match = /\| Level ([\d,]+) (\w+) \| ([\d,]+) acres/.exec(playerInfo);
			var playerLevel = convertToNumber(match[1]);
			jsdump("playerLevel: " + playerLevel);
			var playerClass = match[2];
			jsdump("playerClass: " + playerClass);
			var playerSize = convertToNumber(match[3]);
			jsdump("playerSize: " + playerSize);
			searchItem = searchItems.iterateNext();
		}
	},
	
	handleMessageFeed: function(rotiDocument, messageFeed){
		var feeds = rotiDocument.evaluate('.//li', messageFeed, null, XPathResult.ANY_TYPE, null );
		var feed = feeds.iterateNext();
		while (feed) {
			var message = feed.textContent.trim();
			var match = /^([\d,]+) troops deserted your army because you were unable to pay their upkeep/.exec(message);
			if (match) {
				var desertedTroops = convertToNumber(match[1]);
				jsdump("desertedTroops:" + desertedTroops);
			}
			feed = feeds.iterateNext();
		}
	}
}