/**
 * @author awilliams
 */
var BrimstoneWarbookHandler = {
	handlers : {},

	initialise : function() {
		BrimstoneWarbookHandler.handlers["diplomacy"] = BrimstoneWarbookHandler.handleDiplomacy;
		BrimstoneWarbookHandler.handlers["army"] = BrimstoneWarbookHandler.handleArmy;
		BrimstoneWarbookHandler.handlers["hero"] = BrimstoneWarbookHandler.handleHero;
		BrimstoneWarbookHandler.handlers["kingdom"] = BrimstoneWarbookHandler.handleKingdom;
		BrimstoneWarbookHandler.parameters = BrimstoneData.loadHandlerParameters();		
	},
	
	factionChanged : function() {
//		jsdump("BrimstoneHandler.factionChanged");
		BrimstoneWarbookHandler.lastMessageLog = BrimstoneWarbookHandler.parameters[Brimstone.faction].lastmessagelog;
		if (BrimstoneWarbookHandler.lastMessageLog.value ==  null) {
			BrimstoneWarbookHandler.lastMessageLog.value = "";
		}
		
	},

	handleClick : function(e) {
//		jsdump("Handling click")
		if (false) { // Need to set up an option for whether we are controlling warbook clicks
			e.preventDefault();
			BrimstoneBrowser.loadPage(e.target.href);			
		}
	},
	
	handlePage : function(host, path, DOM) {
		var links = DOM.document.evaluate('//a', DOM.document, null, XPathResult.ANY_TYPE, null );
		var link = links.iterateNext();
		while (link) {
			link.addEventListener("click", BrimstoneHandler.handleClick, true);
			link = links.iterateNext();
		}	
		
		var beboNode = DOM.document.evaluate('./HTML/HEAD/LINK[@href="/stylesheets/bebo.css"]', DOM.document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (beboNode) {
			Brimstone.faction = "bebo";
		} else {
			// Assume facebook
			Brimstone.faction = "facebook";
		}
		
		var pageType = /\/(\w+)\//.exec(path);
		if (pageType == null) {
			pageType = /\/(\w+)/.exec(path);
		}
		if (pageType != null) {
			if (BrimstoneWarbookHandler.handlers[pageType[1]]) {
				var origEventsLength = Brimstone.events.length;
				BrimstoneWarbookHandler.handlers[pageType[1]](DOM, path);
				if (origEventsLength != Brimstone.events.length) {
//					BrimstoneUI.eventsTreeView.dataSourceListener.insertEvent();
//					BrimstoneUI.addEvents(Brimstone.events.slice(origEventsLength))
				}
			} else {
				BrimstoneUI.appendLog("Brimstone: " + pageType[1]);				
			}
		}
		
		BrimstoneWarbookHandler.handleHeader(DOM);		
	},

	handleHeader : function(DOM) {
		var quickStats = DOM.document.getElementById("quick_stats");
		if (Brimstone.player && quickStats) {
			var player = Brimstone.player;
			player.gold = convertToNumber(DOM.document.getElementById("gold").textContent);
			player.size = convertToNumber(DOM.document.getElementById("acres").textContent);
			player.mana = convertToNumber(DOM.document.getElementById("mana").textContent);
			BrimstoneUI.updatePlayerInfo();
			BrimstoneData.savePlayer(Brimstone.player);			
		}
	},
	
	handleLeaderboard : function(DOM, path) {
		BrimstoneUI.appendLog("Leaderboard\n");
		Brimstone.lastPageName = "Leaderboard";
		// TODO: Parse leaderboard
	},
	
	handleUserPage : function(DOM, path) {
		var mainContent = DOM.document.getElementById("main_content");
		if (!mainContent) {
			return;
		}
		var playerProfile = DOM.document.evaluate('./div[@class="profile"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		var playerNameNode = DOM.document.evaluate('./div[@class="alias text_info"]', playerProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		var playerName = playerNameNode.textContent;
		Brimstone.lastPageName = playerName;
//		jsdump("Player name: " + playerName);
		if (!Brimstone.players[playerName]) {
			var player = BrimstoneData.loadPlayer(playerName);
			if (player) {
				Brimstone.players[playerName] = player;
			} else {
				Brimstone.players[playerName] = new playerInfo();
			}
		}
		var player = Brimstone.players[playerName];
		player.name = playerName;
		var match = /\/diplomacy\/userPage\?.*target=([^&]+)/.exec(path);
		player.id = match[1];
		var heroInfo = DOM.document.evaluate('./div[@class="stats text_info"]', playerProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
		var heroMatch = /Level\s+(\d+)\s+(\w+)/.exec(heroInfo);
		player.heroType = heroMatch[2];
		player.level = convertToNumber(heroMatch[1]);
		var playerProfileInfo = DOM.document.evaluate('./div[@class="profile_info"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		player.size = convertToNumber(DOM.document.evaluate('./div[@class="info_box info_data primary first"]', playerProfileInfo, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
		var playerAllianceNode = DOM.document.evaluate('./div[@class="alliance text_info"]', playerProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		var playerTag = DOM.document.evaluate('./a[@class="tag"]', playerAllianceNode, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
		if (playerTag) {
			var allianceURL = playerTag.getAttribute("href");
			if (!Brimstone.alliances[allianceURL]){
				Brimstone.alliances[allianceURL] = new Alliance(allianceURL);
			}
			var alliance = Brimstone.alliances[allianceURL];
			if (alliance.tag != playerTag.textContent) {
				alliance.tag = playerTag.textContent;
				alliance.save();
			}
			player.allianceURL = alliance.url;
//			jsdump("Tag: " + playerTag.getAttribute("href"));
		}
		player.faction = DOM.document.evaluate('./div[@class="info_box info_data secondary first"]', playerProfileInfo, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent.toLowerCase();
//		jsdump("Faction: " + player.faction)

		if (!Brimstone.player || !Brimstone.player.name) {
			// Can't really do much with events if we have no player to relate them to.
			return;
		}
		var message = DOM.document.getElementById("messages");
		if (message) {
			var messageText = message.textContent.replaceWhiteSpace().trim();
			Brimstone.writeEventLog(messageText);
			var spyMatch = /You magically spy on the ([\w\s]+)'s lands/.exec(messageText);
			if (spyMatch) {
				var playerName = spyMatch[1];
				var player = Brimstone.players[playerName];
				if (!player.army) {
					player.army = new armyInfo();
				}
				var army = player.army;
				parseText(messageText, armyInfoParseHints, army);
				var goldMatch = /([\d,-]+) Gold/.exec(messageText);
				player.gold = goldMatch[1].replace(/,/g,"");
				BrimstoneUI.appendLog(playerName + "\n");
				var armyStrength = player.baseArmyStrength;
				BrimstoneUI.appendLog("Gold: " + player.gold + "\n");
				BrimstoneUI.appendLog("Attack: " + armyStrength.attack + "\n");
				BrimstoneUI.appendLog("Defence: " +armyStrength.defence + "\n");
			}
			var surveyMatch = /You magically scry the structures of ([\w\s]+)'s kingdom/.exec(messageText);
			if (surveyMatch) {
				var playerName = surveyMatch[1];
				var player = Brimstone.players[playerName];
				if (!player.kingdom) {
					player.kingdom = new kingdomInfo();
				}				
				var kingdom = player.kingdom;
				parseText(messageText, kingdomInfoParseHints, kingdom);
				kingdom.calculateRatios();
			}
			var userElitesName = Brimstone.player.eliteInfo.plural.toLowerCase();
			var targetElitesName = player.eliteInfo.plural.toLowerCase();
			var attackREString = "You break through ([\\w\\s]+)'s defenses and capture ([\\d,]+) acres of land and ([\\d,]+) gold!You lose ([\\d,]+) soldiers, ([\\d,]+) knights, ([\\d,]+) pikemen, and ([\\d,]+) {0}.They lose ([\\d,]+) soldiers, ([\\d,]+) knights, ([\\d,]+) pikemen, and ([\\d,]+) {1}.".format(userElitesName, targetElitesName)
			var attackMatch = new RegExp(attackREString).exec(messageText);
			if (attackMatch) {
				var event = new brimstoneEvent();
				event.type = "attack";
				event.subject = Brimstone.player.name;
				event.object = attackMatch[1];
				event.subjectDelta = new eventDelta();
				event.subjectDelta.acres = convertToNumber(attackMatch[2]);
				event.subjectDelta.gold = convertToNumber(attackMatch[3]);
				event.subjectDelta.soldiers = convertToNumber(attackMatch[4]);
				event.subjectDelta.pikemen = convertToNumber(attackMatch[5]);
				event.subjectDelta.knights = convertToNumber(attackMatch[6]);
				event.subjectDelta.elites = convertToNumber(attackMatch[7]);
				event.objectDelta = new eventDelta();
				event.objectDelta.acres = -convertToNumber(attackMatch[2]);
				event.objectDelta.gold = -convertToNumber(attackMatch[3]);
				event.objectDelta.soldiers = convertToNumber(attackMatch[8]);
				event.objectDelta.pikemen = convertToNumber(attackMatch[9]);
				event.objectDelta.knights = convertToNumber(attackMatch[10]);
				event.objectDelta.elites = convertToNumber(attackMatch[11]);
//				jsdump("Successful attack.  They lost {0} elites".format(event.objectDelta.elites));
				BrimstoneData.saveEvent(event);
			}
			var failedAttackREString = "Your attack is repelled by ([\\w\\s]+)'s defenses.You lose ([\\d,]+) soldiers, ([\\d,]+) knights, ([\\d,]+) pikemen, and ([\\d,]+) {0}.They lose ([\\d,]+) soldiers, ([\\d,]+) knights, ([\\d,]+) pikemen, and ([\\d,]+) {1}.".format(userElitesName, targetElitesName);
			var failedAttackMatch = new RegExp(failedAttackREString).exec(messageText);
			if (failedAttackMatch) {
				var event = new brimstoneEvent();
				event.type = "attack";
				event.subject = Brimstone.player.name;
				event.object = failedAttackMatch[1];
				event.subjectDelta = new eventDelta();
				event.subjectDelta.acres = 0;
				event.subjectDelta.gold = 0;
				event.subjectDelta.soldiers = convertToNumber(failedAttackMatch[2]);
				event.subjectDelta.pikemen = convertToNumber(failedAttackMatch[3]);
				event.subjectDelta.knights = convertToNumber(failedAttackMatch[4]);
				event.subjectDelta.elites = convertToNumber(failedAttackMatch[5]);
				event.objectDelta = new eventDelta();
				event.objectDelta.acres = 0;
				event.objectDelta.gold = 0;
				event.objectDelta.soldiers = convertToNumber(failedAttackMatch[6]);
				event.objectDelta.pikemen = convertToNumber(failedAttackMatch[7]);
				event.objectDelta.knights = convertToNumber(failedAttackMatch[8]);
				event.objectDelta.elites = convertToNumber(failedAttackMatch[9]);
				BrimstoneData.saveEvent(event);
//				jsdump("Failed attack.  They lost {0} elites".format(event.objectDelta.elites));
			}
			
			var landGrabMatch = /^You magically procure ([\d,-]+) acres of land from ([\w\s]+)./.exec(messageText);
			if (landGrabMatch) {
				var event = new brimstoneEvent();
				event.type = "landGrab";
				event.subject = Brimstone.player.name;
				event.object = landGrabMatch[2];
				event.subjectDelta = new eventDelta();
				event.subjectDelta.acres = convertToNumber(landGrabMatch[1]);
				event.objectDelta = new eventDelta();
				event.objectDelta.acres = -convertToNumber(landGrabMatch[1]);
				BrimstoneData.saveEvent(event);
			}
//				var fireballREString = "^Your fireball rips through ([\\w\\s]+)'s lands, annihilating ([\\d,]+) soldiers, ([\\d,]+) knights, ([\\d,]+) pikemen, and ([\\d,]+) {0}.".format(targetElitesName);
			var match = /^Your fireball rips through ([\w\s]+)'s lands, annihilating ([\d,]+) soldiers, ([\d,]+) knights, ([\d,]+) pikemen, and ([\d,]+) elites./.exec(messageText);
			if (match) {
				var event = new brimstoneEvent();
				event.type = "fireball";
				event.subject = Brimstone.player.name;
				event.object = match[1];
				event.objectDelta = new eventDelta();
				event.objectDelta.acres = 0;
				event.objectDelta.gold = 0;
				event.objectDelta.soldiers = convertToNumber(match[2]);
				event.objectDelta.pikemen = convertToNumber(match[3]);
				event.objectDelta.knights = convertToNumber(match[4]);
				event.objectDelta.elites = convertToNumber(match[5]);					
				BrimstoneData.saveEvent(event); 
			}
			// If there is a message then we must have done some action to the player
			// Save the player for future reference
			BrimstoneData.savePlayer(player)
		}
		BrimstoneUI.updateTargetInfo(player);
	},
	
	handleDiplomacy : function(DOM, path) {
		try {
			if (path == "/Diplomacy" || path == "/Diplomacy/") {
				//Nothing to see here
				return;
			}
			if (/leaderboard/.exec(path)) {
				BrimstoneWarbookHandler.handleLeaderboard(DOM, path);
				return;
			}
			var userPageMatch = /\/diplomacy\/userPage\?/.exec(path);
			if (userPageMatch) {
//				player.id = userPageMatch[1];
				BrimstoneWarbookHandler.handleUserPage(DOM, path);
				return;
//				jsdump("id:" + userPageMatch[1]+ ":" + player.id);
			}
			BrimstoneUI.appendLog("Diplomacy\n");
			var mainContent = DOM.document.getElementById("main_content");
			if (!mainContent) {
				return;
			}
			var playerCount = 0;
			var players = {};
			var playerDescriptions = DOM.document.evaluate('./div[substring(@class,0,7)="player"]', mainContent, null, XPathResult.ANY_TYPE, null );
			var playerDescription = playerDescriptions.iterateNext();
			while (playerDescription) {
				playerCount++;
				playerNode = DOM.document.evaluate( './a[1]', playerDescription, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
				var playerName = playerNode.textContent.trim();
				if (!Brimstone.players[playerName]) {
					Brimstone.players[playerName] = new playerInfo();
				}
				var player = Brimstone.players[playerName];
				player.name = playerName;
				var factionImgSrc = DOM.document.evaluate( './div[1]/img/@src', playerDescription, null, XPathResult.STRING_TYPE, null ).stringValue;
//				jsdump("factionimgurl: " + factionImgSrc)
				var match = /images\/(\w+)\.png/.exec(factionImgSrc);
				player.faction = match[1];
				var allianceNode = DOM.document.evaluate('./a[@class="tag"]', playerDescription, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
				if (allianceNode) {
					var allianceURL = allianceNode.getAttribute("href");
					if (!Brimstone.alliances[allianceURL]){
						Brimstone.alliances[allianceURL] = new Alliance(allianceURL);
					}
					var alliance = Brimstone.alliances[allianceURL];
					if (alliance.tag != allianceNode.textContent) {
						alliance.tag = allianceNode.textContent;
						alliance.save();
					}
					player.allianceURL = alliance.url;
				}
				var heroInfo = DOM.document.evaluate( './span[1]', playerDescription, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
				var size = DOM.document.evaluate( './span[2]', playerDescription, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
				var sizeMatch = /(\d+)\s+acres/.exec(size);
				player.size = convertToNumber(sizeMatch[1]);
				var heroMatch = /Level\s+(\d+)\s+(\w+)/.exec(heroInfo);
				player.heroType = heroMatch[2];
				player.level = convertToNumber(heroMatch[1]);
				players[playerName] = player;
				playerDescription = playerDescriptions.iterateNext();
			}
	
			var DBConn = BrimstoneData.xuluData.newConnection();
			BrimstoneData.xuluData.beginTransaction(DBConn);
			for (var playerName in players) {
				var player = Brimstone.players[playerName];
				if (BrimstoneOptions.saveSearchResults || player.army || player.kingdom) {
					BrimstoneData.savePlayer(player, DBConn)
				}
			}
			BrimstoneData.xuluData.commitTransaction(DBConn)
			
			if (playerCount == 1) {
				BrimstoneUI.updateTargetInfo(player);
			}
			var a = 1;
		} catch(e) {
			BrimstoneErrorHandler.handleError("parsing diplomacy page", e);
		}
	},
	
	handleArmy : function(DOM) {
		try {
			BrimstoneUI.appendLog("Army\n");
			Brimstone.lastPageName = "Army";
			var mainContent = DOM.document.getElementById("main_content");
			if (!Brimstone.player) {
				Brimstone.player = new playerInfo();
			}
			if (!Brimstone.player.army) {
				Brimstone.player.army = new armyInfo();
			}
			var army = Brimstone.player.army;
			army.soldiers = convertToNumber(DOM.document.evaluate('./div[@class="info twothirds big soldier"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
			army.knights = convertToNumber(DOM.document.evaluate('./div[@class="info twothirds big knight"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
			army.pikemen = convertToNumber(DOM.document.evaluate('./div[@class="info twothirds big pikeman"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
			army.elites = convertToNumber(DOM.document.evaluate('./div[@class="info twothirds big elite"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);

			BrimstoneUI.invalidateDefenceStyling()
		} catch(e) {
			BrimstoneErrorHandler.handleError("parsing army page", e);
		}			
	},

	handleHero : function(DOM) {
		try {
			BrimstoneUI.appendLog("Hero\n");
			Brimstone.lastPageName = "Hero";
			var mainContent = DOM.document.getElementById("main_content");
			if(!mainContent) {
				return;
			}
			if (!Brimstone.player) {
				Brimstone.player = new playerInfo();
			}
			var player = Brimstone.player;
			var playerProfile = DOM.document.evaluate('./div[@class="profile"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
			var playerNameNode = DOM.document.evaluate('./div[@class="alias text_info"]', playerProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;
			var playerName = playerNameNode.textContent;
			if (playerName != player.name) {
				switch (Brimstone.faction) {
					case "bebo" :
						BrimstoneOptions.beboPlayerName = playerName;
						break;
					case "facebook" :
						BrimstoneOptions.facebookPlayerName = playerName;
						break;
				}
				player.name = playerName;
			}
			var heroInfo = DOM.document.evaluate('./div[@class="stats text_info"]', playerProfile, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent;
			var heroMatch = /Level\s+(\d+)\s+(\w+)/.exec(heroInfo);
			player.heroType = heroMatch[2];
			player.level = convertToNumber(heroMatch[1]);
	
			if (!player.stats) {
				player.stats = new Stats();
			}
			var playerProfileInfo = DOM.document.evaluate('./div[@class="profile_info"]', mainContent, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue;

			player.stats.attack = convertToNumber(DOM.document.evaluate('./div[@class="info_box info_data primary first"]', playerProfileInfo, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
			player.stats.defence = convertToNumber(DOM.document.evaluate('./div[@class="info_box info_data primary second"]', playerProfileInfo, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
			player.stats.spellPower = convertToNumber(DOM.document.evaluate('./div[@class="info_box info_data primary third"]', playerProfileInfo, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent);
			var manaString = DOM.document.evaluate('./div[@class="info_box info_data primary fourth"]', playerProfileInfo, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null ).singleNodeValue.textContent
			var match = /[\d,]+ \/ ([\d,]+)/.exec(manaString)
			player.stats.maxMana = convertToNumber(match[1]);
			
//			parseText(mainContent.textContent, statsParseHints, player.stats);
		} catch(e) {
			BrimstoneErrorHandler.handleError("parsing hero page", e);
		}
	},
	
	handleHomePage : function(DOM, path) {
		Brimstone.lastPageName = "Home";
		var message = DOM.document.getElementById("messages");
		if (Brimstone.player && Brimstone.player.name && message) {
			try {
				var DBConn = BrimstoneData.xuluData.newConnection();
				BrimstoneData.xuluData.beginTransaction(DBConn);
				var messageContent = message.textContent.replaceWhiteSpace().replace(/^\s+|\s+$/gm, "\n");
				messageContent = messageContent.replace(/\n\n/g, "")
				messageContent = messageContent.replace(/^\n/,"");
				messageContent = messageContent.replace("more...\n", "");
				messageContent = messageContent.replace("delete...\n", "");
				var timestampRE = /\[((\d+) days?, )?(\d\d):(\d\d):(\d\d) ago\]/g
				var messageWithoutTimeStamp = messageContent.replace(timestampRE, "");
				if (path == "/kingdom" || path == "/kingdom/") {
					if (messageContent.split("\n").length == 27) {
						// Potential message overflow
//							jsdump("Potential message overflow");
						var oldMessages = BrimstoneWarbookHandler.lastMessageLog.value.split("\n");
						var newMessagesEnd = -1;
						for (var i=oldMessages.length - 1; i>0; i--) {
//								jsdump("Trying oldMessages - " + oldMessages.length-i-1)
							newMessagesEnd = messageWithoutTimeStamp.lastIndexOf(oldMessages.slice(0, i).join("\n"));
							if (newMessagesEnd == -1) {
								// Try again
							} else {
//									jsdump("Match found");
								var newMessages = messageContent.substring(0, newMessagesEnd);
								break;
							}
						}
						if (newMessagesEnd == -1) {
							var newMessages = messageContent;
						}
					} else {
						var newMessagesEnd = messageWithoutTimeStamp.indexOf(BrimstoneWarbookHandler.lastMessageLog.value)
						if (BrimstoneWarbookHandler.lastMessageLog.value.length == 0 || newMessagesEnd == -1) {
							var newMessages = messageContent;
						} else {
							var newMessages = messageContent.substring(0, newMessagesEnd);
						}
					}
					BrimstoneWarbookHandler.lastMessageLog.value = messageWithoutTimeStamp;
					BrimstoneWarbookHandler.lastMessageLog.save(DBConn);
				} else {
					var newMessages = messageContent;
				}
//					if (messageContent.indexOf(Brimstone.lastMessageLog) == -1)
				var eventTextArray = newMessages.split("\n");
				for (var i = eventTextArray.length - 1; i >= 0; i--) {
					eventText = eventTextArray[i].trim();
					if (eventText) {
						Brimstone.writeEventLog(eventText);
						var event = new brimstoneEvent();
						event.type = "unknown";
						var match = /^Your kingdom is under attack by (the forces of )?([^!]+)!/.exec(eventText);
						if (match) {
							// Your kingdom has been attacked
							event.subject = match[2].trim();
							event.object = Brimstone.player.name;
							event.type = "attack";
							event.objectDelta = new eventDelta();
							event.subjectDelta = new eventDelta();
							var attacker = match[1];
							match = /You lost the battle, losing ([\d,]+) troops, ([\d,]+) acres, and ([\d,]+) gold./.exec(eventText);
							if (match) {
								// Lost the battle
//									jsdump("Attacked by {0} and lost {1} troops, {2} acres and {3} gold".format(attacker, match[1], match[2], match[3]));
								event.objectDelta.troops = -convertToNumber(match[1]);
								event.objectDelta.acres = -convertToNumber(match[2]);
								event.objectDelta.gold = -convertToNumber(match[3]);
								event.subjectDelta.acres = convertToNumber(match[2]);
								event.subjectDelta.gold = convertToNumber(match[3]);
							} else {
								match = /You won the battle, but lost ([\d,]+) troops./.exec(eventText);
								if (match) {
									event.objectDelta.troops = -convertToNumber(match[1]);
									event.objectDelta.acres = 0;
									event.objectDelta.gold = 0;
									event.subjectDelta.acres = 0;
									event.subjectDelta.gold = 0;
								} else {
									jsdump("Couldn't parse attack message\n" + eventText)
								}
//									jsdump("Attacked by {0} and won but lost {1} troops.".format(attacker, match[1]));
							}
						}
						var match = /^For ([\w\s]+) has proposed a trade agreement./.exec(eventText);
						if (match) {
							event.type = "traderequest";
							event.subject = match[1].trim();
							event.object = Brimstone.player.name;
							jsdump("Trade request from {0}".format(event.subject));
						}
						
						var match = /^([\w\s]+) says: (.+)$/.exec(eventText);
						if (match) {
							event.type = "message";
							event.subject = match[1].trim();
							event.object = Brimstone.player.name;
							event.message = match[2];
//									jsdump("'{0}' said {1}".format(event.subject, event.message));
						}
						var match = /^Your hero gains level (\d+)!/.exec(eventText);
						if (match) {
							event.type = "levelup"
							event.subject = Brimstone.player.name;
							event.message = match[1];
						}
						var match = /^([\w\s]+) has sent you ([\d,]+) gold./.exec(eventText);
						if (match) {
							event.type = "gift"
							event.subject = match[1].trim();
							event.object = Brimstone.player.name;
							event.objectDelta = new eventDelta();
							event.objectDelta.gold = convertToNumber(match[2]);
						}
						var match = /^([\w\s]+) magically steals ([\d,]+) acres from you./.exec(eventText);
						if (match) {
							event.type = "landGrab";
							event.subject = match[1].trim();
							event.subjectDelta = new eventDelta();
							event.subjectDelta.acres = convertToNumber(match[2]);
							event.object = Brimstone.player.name;
							event.objectDelta = new eventDelta();
							event.objectDelta.acres = -convertToNumber(match[2]);
						}
						var match = /^([\w\s]+) casts a fireball that rips through your lands, annihilating ([\d,]+) soldiers, ([\d,]+) knights, ([\d,]+) pikemen, and ([\d,]+) elites./.exec(eventText);
						if (match) {
							event.type = "fireball";
							event.subject = match[1].trim();
							event.object = Brimstone.player.name;
							event.objectDelta = new eventDelta();
							event.objectDelta.soldiers = convertToNumber(match[2]);
							event.objectDelta.pikemen = convertToNumber(match[3]);
							event.objectDelta.knights = convertToNumber(match[4]);
							event.objectDelta.elites = convertToNumber(match[5]);
						}
						BrimstoneData.saveEvent(event, DBConn);
					}
				}
			} finally {
				BrimstoneData.xuluData.commitTransaction(DBConn);
				if (eventTextArray && eventTextArray.length > 0) {
					BrimstoneUI.eventsTreeView.invalidate();
				}
			}
			var newPlayers = {};
			var playerLinks = DOM.document.evaluate('.//a', message, null, XPathResult.ANY_TYPE, null );
			var playerLink = playerLinks.iterateNext();
			while (playerLink) {
//				jsdump("Link for " + playerLink.textContent+ ":" + playerLink.getAttribute("href"));
				var userPageMatch = /\/diplomacy\/userPage\?.*target=([^&]+)/.exec(playerLink.getAttribute("href"));
				if (userPageMatch) {
					var playerName = playerLink.textContent;
					if (Brimstone.players[playerName]) {
						var player = Brimstone.players[playerName]
					} else {
						var player = new playerInfo();
						player.name = playerName;
						Brimstone.players[playerName] = player;
						newPlayers[playerName] = player;
					}
					player.id = userPageMatch[1];
//					jsdump("id:" + userPageMatch[1]+ ":" + player.id);
				}
				playerLink = playerLinks.iterateNext();
			}
		}
	},
	
	handleKingdom : function(DOM, path) {
		if (path == "/kingdom" || path == "/kingdom/") {
			BrimstoneWarbookHandler.handleHomePage(DOM, path);
			return;
		}
		try {
			BrimstoneUI.appendLog("Kingdom\n");
			Brimstone.lastPageName = "Kingdom"; 
			var mainContent = DOM.document.getElementById("main_content");
			if (mainContent) {
				var infoItems = DOM.document.evaluate('./div[@class="info half big"]', mainContent, null, XPathResult.ANY_TYPE, null );
				var freeLandDOM = infoItems.iterateNext();
				if (freeLandDOM) {
					if (!Brimstone.player) {
						Brimstone.player = new playerInfo();
					}
					if (!Brimstone.player.kingdom) {
						Brimstone.player.kingdom = new kingdomInfo();
					}
					var kingdom = Brimstone.player.kingdom;
					kingdom.freeLand = convertToNumber(freeLandDOM.textContent);
					infoItems.iterateNext();
					kingdom.mines = convertToNumber(infoItems.iterateNext().textContent);
					infoItems.iterateNext();
					kingdom.forts = convertToNumber(infoItems.iterateNext().textContent);
					infoItems.iterateNext();
					kingdom.trainingGrounds = convertToNumber(infoItems.iterateNext().textContent);
					infoItems.iterateNext();
					kingdom.barracks = convertToNumber(infoItems.iterateNext().textContent);
					infoItems.iterateNext();
					kingdom.amplifiers = convertToNumber(infoItems.iterateNext().textContent);
					infoItems.iterateNext();
					kingdom.barriers = convertToNumber(infoItems.iterateNext().textContent);
					if (Brimstone.player.size) {
						kingdom.calculateRatios(Brimstone.player.size)
					}
					BrimstoneBuildingCalculatorUI.update(Brimstone.player);
				}
				var a = 1;
			}
		} catch(e) {
			BrimstoneErrorHandler.handleError("parsing kingdom page", e);
		}		
	}

}
