/**
 * @author Awilliams
 */

var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
var proxyPrefs = prefs.getBranch("network.proxy.");
prefs = prefs.getBranch("extensions.brimstone.");

function jsdump(str)
{
	Components.classes['@mozilla.org/consoleservice;1']
             .getService(Components.interfaces.nsIConsoleService)
             .logStringMessage(str);
}

var BrimstoneOptions = {
	initialise : function() {
		if (document.title == "Options") {
			BrimstoneOptionsUI.initialise();
			BrimstoneOptions.loadOptions();
		}
	},
	
	loadOptions : function() {
		BrimstoneOptionsUI.leaveWarbookInFrameOption.checked = BrimstoneOptions.leaveWarbookInFrameOption;
		BrimstoneOptionsUI.hideBlankValues.checked = BrimstoneOptions.hideBlankValues;
		BrimstoneOptionsUI.noMaxWidth.checked = BrimstoneOptions.noMaxWidth;
		BrimstoneOptionsUI.loadPageOnDblClick.checked = BrimstoneOptions.loadPageOnDblClick;
		BrimstoneOptionsUI.writeEventLog.checked = BrimstoneOptions.writeEventLog;
		BrimstoneOptionsUI.saveSearchResults.checked = BrimstoneOptions.saveSearchResults;
		BrimstoneOptionsUI.easyTargetTolerance.value = BrimstoneOptions.easyTargetTolerance;
		BrimstoneOptionsUI.improbableTargetTolerance.value = BrimstoneOptions.improbableTargetTolerance;
		BrimstoneOptionsUI.useProxy.checked = BrimstoneOptions.useProxy;
		BrimstoneOptionsUI.proxy.value = BrimstoneOptions.proxy;
		BrimstoneOptionsUI.proxyPort.value = BrimstoneOptions.proxyPort;
//		alert(proxyPrefs.getIntPref("type"));
	},

	saveOptions : function() {
//		jsdump(BrimstoneOptionsUI.leaveWarbookInFrameOption.label + " : " + BrimstoneOptionsUI.leaveWarbookInFrameOption.checked);
		BrimstoneOptions.leaveWarbookInFrameOption = BrimstoneOptionsUI.leaveWarbookInFrameOption.checked;
		BrimstoneOptions.hideBlankValues = BrimstoneOptionsUI.hideBlankValues.checked;
		BrimstoneOptions.noMaxWidth = BrimstoneOptionsUI.noMaxWidth.checked;
		BrimstoneOptions.loadPageOnDblClick = BrimstoneOptionsUI.loadPageOnDblClick.checked;
		BrimstoneOptions.writeEventLog = BrimstoneOptionsUI.writeEventLog.checked;
		BrimstoneOptions.saveSearchResults = BrimstoneOptionsUI.saveSearchResults.checked;
		BrimstoneOptions.easyTargetTolerance = BrimstoneOptionsUI.easyTargetTolerance.value;
		BrimstoneOptions.improbableTargetTolerance = BrimstoneOptionsUI.improbableTargetTolerance.value;
		BrimstoneOptions.useProxy = BrimstoneOptionsUI.useProxy.checked;
		BrimstoneOptions.proxy = BrimstoneOptionsUI.proxy.value;
		BrimstoneOptions.proxyPort = BrimstoneOptionsUI.proxyPort.value;
	}
}

BrimstoneOptions.__defineGetter__("leaveWarbookInFrameOption", function() {
		if (prefs.prefHasUserValue("leaveWarbookInFrameOption")) {
			return prefs.getBoolPref("leaveWarbookInFrameOption");
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("leaveWarbookInFrameOption", function(value) {
		prefs.setBoolPref("leaveWarbookInFrameOption", value);
});

BrimstoneOptions.__defineGetter__("hideBlankValues", function() {
		if (prefs.prefHasUserValue("hideBlankValues")) {
			return prefs.getBoolPref("hideBlankValues");
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("hideBlankValues", function(value) {
		prefs.setBoolPref("hideBlankValues", value);
});	

BrimstoneOptions.__defineGetter__("noMaxWidth", function() {
		if (prefs.prefHasUserValue("noMaxWidth")) {
			return prefs.getBoolPref("noMaxWidth");
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("noMaxWidth", function(value) {
		prefs.setBoolPref("noMaxWidth", value);
});

BrimstoneOptions.__defineGetter__("oldPlayerName", function() {
		if (prefs.prefHasUserValue("player.name")) {
			return prefs.getCharPref("player.name");
		} else {
			return "";
		}
});

BrimstoneOptions.__defineSetter__("oldPlayerName", function(value) {
		prefs.setCharPref("player.name", value);
});

BrimstoneOptions.__defineSetter__("beboPlayerName", function(value) {
		prefs.setCharPref("player.beboName", value);
});

BrimstoneOptions.__defineGetter__("beboPlayerName", function() {
		if (prefs.prefHasUserValue("player.beboName")) {
			return prefs.getCharPref("player.beboName");
		} else {
			return "";
		}
});

BrimstoneOptions.__defineSetter__("facebookPlayerName", function(value) {
		prefs.setCharPref("player.facebookName", value);
});

BrimstoneOptions.__defineGetter__("facebookPlayerName", function() {
		if (prefs.prefHasUserValue("player.facebookName")) {
			return prefs.getCharPref("player.facebookName");
		} else {
			return "";
		}
});


BrimstoneOptions.__defineGetter__("warbookHost", function() {
		if (prefs.prefHasUserValue("warbook.host")) {
			return prefs.getCharPref("warbook.host");
		} else {
			return "";
		}
});

BrimstoneOptions.__defineSetter__("warbookHost", function(value) {
		prefs.setCharPref("warbook.host", value);
});

BrimstoneOptions.__defineGetter__("loadPageOnDblClick", function() {
		if (prefs.prefHasUserValue("loadPageOnDblClick")) {
			return prefs.getBoolPref("loadPageOnDblClick");
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("loadPageOnDblClick", function(value) {
		prefs.setBoolPref("loadPageOnDblClick", value);
});

BrimstoneOptions.__defineGetter__("writeEventLog", function() {
		if (prefs.prefHasUserValue("writeEventLog")) {
			return prefs.getBoolPref("writeEventLog");
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("writeEventLog", function(value) {
		prefs.setBoolPref("writeEventLog", value);
});

BrimstoneOptions.__defineGetter__("saveSearchResults", function() {
		if (prefs.prefHasUserValue("saveSearchResults")) {
			return prefs.getBoolPref("saveSearchResults");
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("saveSearchResults", function(value) {
		prefs.setBoolPref("saveSearchResults", value);
});

BrimstoneOptions.__defineGetter__("easyTargetTolerance", function() {
		if (prefs.prefHasUserValue("easyTargetTolerance")) {
			return prefs.getIntPref("easyTargetTolerance")
		} else {
			return 20;
		}
});

BrimstoneOptions.__defineSetter__("easyTargetTolerance", function(value) {
		prefs.setIntPref("easyTargetTolerance", value);
});

BrimstoneOptions.__defineGetter__("improbableTargetTolerance", function() {
		if (prefs.prefHasUserValue("improbableTargetTolerance")) {
			return prefs.getIntPref("improbableTargetTolerance");
		} else {
			return 10;
		}
});

BrimstoneOptions.__defineSetter__("improbableTargetTolerance", function(value) {
		prefs.setIntPref("improbableTargetTolerance", value);
});

BrimstoneOptions.__defineGetter__("useProxy", function() {
		if (proxyPrefs.prefHasUserValue("type")) {
			return proxyPrefs.getIntPref("type") == 1;
		} else {
			return false;
		}
});

BrimstoneOptions.__defineSetter__("useProxy", function(value) {
		proxyPrefs.setIntPref("type", value ? 1 : 0);
});

BrimstoneOptions.__defineGetter__("proxy", function() {
		if (proxyPrefs.prefHasUserValue("http")) {
			return proxyPrefs.getCharPref("http");
		} else {
			return "";
		}
});

BrimstoneOptions.__defineSetter__("proxy", function(value) {
		proxyPrefs.setCharPref("http", value);
		proxyPrefs.setCharPref("ssl", value);
});

BrimstoneOptions.__defineGetter__("proxyPort", function() {
		if (proxyPrefs.prefHasUserValue("http_port")) {
			return proxyPrefs.getIntPref("http_port");
		} else {
			return "";
		}
});

BrimstoneOptions.__defineSetter__("proxyPort", function(value) {
		proxyPrefs.setIntPref("http_port", value);
		proxyPrefs.setIntPref("ssl_port", value);
});

var BrimstoneOptionsUI = {
	showProxyOptions : false,
	leaveWarbookInFrameOption : null,
	loadPageOnDblClick : null,
	writeEventLog : null,
	saveSearchResults : null,
	useProxy : null,
	proxy : null,
	proxyPort : null,
	
	initialise : function() {
		BrimstoneOptionsUI.leaveWarbookInFrameOption = document.getElementById("leaveWarbookInFrameOption");
		BrimstoneOptionsUI.hideBlankValues = document.getElementById("hideBlankValues");
		BrimstoneOptionsUI.noMaxWidth = document.getElementById("noMaxWidth");
		BrimstoneOptionsUI.loadPageOnDblClick = document.getElementById("loadPageOnDblClick");
		switch (XULU_APP_RELEASE_TYPE) {
			case "development" :
			case "beta" :
				BrimstoneOptionsUI.loadPageOnDblClick.setAttribute("collapsed", false);
		}
		BrimstoneOptionsUI.writeEventLog = document.getElementById("writeEventLog");
		BrimstoneOptionsUI.saveSearchResults = document.getElementById("saveSearchResults");
		BrimstoneOptionsUI.easyTargetTolerance = document.getElementById("easyTargetTolerance");
		BrimstoneOptionsUI.improbableTargetTolerance = document.getElementById("improbableTargetTolerance");
		BrimstoneOptionsUI.useProxy = document.getElementById("useProxy");
		BrimstoneOptionsUI.proxy = document.getElementById("proxy");
		BrimstoneOptionsUI.proxyPort = document.getElementById("proxyPort");
		BrimstoneOptionsUI.proxyOptions = document.getElementById("proxyOptions");
		BrimstoneOptionsUI.showProxyOptions = BrimstoneVariant.BrimstoneOptionsUI.showProxyOptions;
		BrimstoneOptionsUI.proxyOptions.setAttribute("collapsed", !BrimstoneOptionsUI.showProxyOptions);
	},
	
	clearDataClicked : function() {
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
		var result = prompts.confirm(window, "Delete data?", "Are you sure you want to delete ALL Brimstone data?");
		if (result) {
			BrimstoneData.initialise();
			BrimstoneData.cleanData();
			try {
				prefs.deleteBranch("");
			} catch(e) {
				// This will throw an error if the branch doesn't exist.  i.e. New user or the branch has already been reset
			}
			BrimstoneOptions.facebookPlayerName = "";
			BrimstoneOptions.loadOptions();
			// Setting a (blank) value for the facebook name will force Brimstone to reload;
//			prefs.clearUserPref("player.name");
//			prefs.clearUserPref("player.facebookName");
			alert("All Brimstone data has been removed");
		}
	},
	
	OKClicked : function() {
		BrimstoneOptions.saveOptions();
		window.close();		
	},
	
	cancelClicked : function() {
		window.close();
	}
}

window.addEventListener('load', BrimstoneOptions.initialise, false);
// window.addEventListener('unload', Brimstone.onClose, false);
