/**
 * @author Awilliams
 */

String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ''); }

String.prototype.format = function()
{
    var str = this;

    for(var i=0;i<arguments.length;i++)
    {
        var re = new RegExp('\\{' + (i) + '(:(0+))?\\}','gm');
        var match = re.exec(str);
        str = str.replace(re, getReplaceFunc(arguments[i]));
    }
    return str;
}

function getReplaceFunc(replaceValue) {
    return function (str, p1, p2, offset, s) {
            if (p2) {
                var paddedValue = padLeft(replaceValue, p2.length)
                return paddedValue;
            } else {
                return replaceValue;
            }
        }
}

function padLeft(origString, length) {
	var s = "" + origString;
	if (s.length < length) {
		return new Array(length - s.length + 1).join(0) + s;
	} else {
		return new String(s);
	}
}

function padRight(origString, length) {
	var s = "" + origString;
	if (s.length < length) {
		return s + new Array(length - s.length + 1).join(0);
	} else {
		return new String(s);
	}
}

function formatNumberAsString(decimalDigits,value)
{
	if (value == null) {
		return null;
	}	

	// Separator Length. Here this is thousand separator
	var separatorLength = 3;
	var tempValueString = "" + value;
	var valueString = "";

	// Store digits after decimal
	var pStr;
	
	// store digits before decimal
	var dStr;
	
	var decimalIndex = tempValueString.indexOf(".");
	// Add decimal point if it is not there
	if (decimalIndex==-1)
	{
		dStr = tempValueString;
		pStr = ".";
	} else {
		dStr=tempValueString.substr(0,decimalIndex);	
		pStr=tempValueString.substr(decimalIndex)		
	}


	// Add "0" for remaining digits after decimal point
	pStr =  padRight(pStr, decimalDigits + 1);
	if (pStr.length - 1 > decimalDigits) {
		var temp = parseInt(pStr.substr(1));
		var divisor = Math.pow(10, (pStr.length - 1 - decimalDigits));
		temp /= divisor;
		temp = Math.round(temp);
		pStr = "." + temp;
	}

	if(pStr =='.') {
		pStr =''; 
	}   
  
	if(dStr.length > separatorLength)
	{
		// Logic of separation
		while( dStr.length > separatorLength)
		{
			valueString = "," + dStr.substr(dStr.length - separatorLength) + valueString;
			dStr = dStr.substr(0,dStr.length - separatorLength);
		}
		valueString = dStr + valueString;
	}
	else
	{
		valueString = dStr;
	}
	// Add decimal part
	valueString += pStr;
	return valueString;
}

Math.roundTo = function(value, dp) {
	var multiplier = Math.pow(10, dp);
	return Math.round(value * multiplier) / multiplier;
}

function jsdump(str)
{
	Components.classes['@mozilla.org/consoleservice;1']
             .getService(Components.interfaces.nsIConsoleService)
             .logStringMessage(str);
}

function getFileHandle(path) {
	var fileHandle = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);
	fileHandle.initWithPath(path);	
	return fileHandle;
}

var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);

var scriptError = Components.classes["@mozilla.org/scripterror;1"]
                      .createInstance(Components.interfaces.nsIScriptError);

function myLogToConsole(aMessage, aSourceName, aSourceLine, aLineNumber, 
                        aColumnNumber, aFlags, aCategory)
{
	scriptError.init(aMessage, aSourceName, aSourceLine, aLineNumber, 
                   aColumnNumber, aFlags, aCategory);
	consoleService.logMessage(scriptError);
}

var XuluErrorHandler = {
	handleError : function(failedAction, e, DBConn) {
		if (e.DBError) {
			var lineNumber = e.DBError.lineNumber;
			var fileName = e.DBError.filename;
			var message = e.message.substring(0, e.message.length);
		} else {
			var lineNumber = e.lineNumber;			
			var fileName = e.fileName;
			var message = e.message;
		}
		myLogToConsole(message, fileName, null, lineNumber, 0, scriptError.errorFlag, "javascript");
		message = "An error occured doing {0}:\n{1}\n{2}:{3}\n{4}".format(failedAction, message, fileName, lineNumber, e.stack);
		jsdump(message);
		if (XULU_APP_RELEASE_TYPE == "development") {
			alert(message);
		} else if (XULU_APP_RELEASE_TYPE == "beta") {
			// Send message to error server
		}
		try {
			message += "\n\n";
			var file = Components.classes["@mozilla.org/file/local;1"]
		                     .createInstance(Components.interfaces.nsILocalFile);
	
			file.initWithPath(Brimstone.installedPath);
			file.append("error.log");
			var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
			                         .createInstance(Components.interfaces.nsIFileOutputStream);
			
			// use 0x02 | 0x10 to open file for appending.
			foStream.init(file, 0x02 | 0x08 | 0x10, 0666, 0); // write, create, append
			foStream.write(message, message.length);
			foStream.close();
		} catch (e) {
			
		}
	}
}
